﻿//+------------------------------------------------------------------+
//|                                                  PanelDialog.mqh |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   "1.00"
#property strict

#include <Controls\Dialog.mqh>
#include <Controls\Edit.mqh>

class exampleFlickingDlg : public CAppDialog
{
private:
  CEdit       m_edit;
public:
  exampleFlickingDlg();
  ~exampleFlickingDlg();
  
  //--- creation
  virtual bool Create( const long chart, const string name, const int subwin, const int x1, const int y1, const int x2, const int y2);

  //--- chart event handler
  virtual bool OnEvent( const int id, const long &lparam, const double &dparam, const string &sparam);
  
  void UpdateDataTick( void);
  void UpdateDataTimer( void);
  void UpdateData( bool, bool, bool, bool, bool);
  void RedrawRiskSlider( double dblRiskValue);
  
protected:
  virtual void Maximize(void);
  bool CreateControls( void);
  
  //--- internal event handlers
  virtual bool OnResize( void);
};

//+------------------------------------------------------------------+
//| Event handling                                                   |
//+------------------------------------------------------------------+
EVENT_MAP_BEGIN( exampleFlickingDlg)
  //const int id,const long& lparam,const double& dparam,const string& sparam
  //PrintFormat( __FUNCTION__ + "   id=%d   lparam=%ld   dparam=%f   sparam=%s", id, lparam, dparam, sparam);
EVENT_MAP_END( CAppDialog)

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
exampleFlickingDlg::exampleFlickingDlg()
{
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
exampleFlickingDlg::~exampleFlickingDlg()
{
}

//+------------------------------------------------------------------+
//| Creation                                                         |
//+------------------------------------------------------------------+
bool exampleFlickingDlg::Create( const long chart, const string name, const int subwin,
                           const int x1, const int y1, const int x2, const int y2)
{
  //--- calling the parent class method
  if( !CAppDialog::Create( chart, name, subwin, x1, y1, x2, y2))
    return( false);

  //--- creating additional elements
  if( !CreateControls())    { Print( "1"); return( false); }

  //--- success
  return( true);
}

bool exampleFlickingDlg::CreateControls( void)
{
  if( !m_edit.Create( m_chart_id, m_name + "_EditDemo", m_subwin, 1, 1, 108, 19)) return( false);
  if( !Add( m_edit)) return( false);
  
  //--- success
  return( true);
}

//+------------------------------------------------------------------+
//| Resize handler                                                   |
//+------------------------------------------------------------------+
bool exampleFlickingDlg::OnResize(void)
{
  //--- calling the parent class method
  if( !CAppDialog::OnResize()) return( false);

  //--- success
  return( true);
}

void exampleFlickingDlg::UpdateDataTick( void) {
}

void exampleFlickingDlg::UpdateDataTimer( void)
{
}

void exampleFlickingDlg::Maximize()
{
  CAppDialog::Maximize();
}